/*
 * carl9170 firmware - used by the ar9170 wireless device
 *
 * Firmware header definition
 *
 * Copyright	2009	Christian Lamparter <chunkeey@googlemail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __HDR_H
#define __HDR_H

#include "compiler.h"
#include "types.h"
#include "linux/fwhdr.h"

struct carl9170_firmware_descriptor {
	struct carl9170_fw_otus_desc_v1 otus;
	struct carl9170_fw_usb_desc_v1 usb;
#ifdef CONFIG_CARL9170FW_HEADER_MOTD
	struct carl9170_fw_motd_desc_v1 motd;
#endif /* CONFIG_CARL9170FW_HEADER_MOTD */
#ifdef CONFIG_CARL9170FW_DEBUG
	struct carl9170_fw_debug_desc_v1 debug;
#endif /* CONFIG_CARL9170FW_DEBUG */
	struct carl9170_fw_last_desc_v1 last;
} __packed;

extern const struct carl9170_firmware_descriptor carl9170_fw_desc;

static inline void __check_fw(void)
{
	BUILD_BUG_ON(sizeof(carl9170_fw_desc) & 0x3);
	BUILD_BUG_ON(sizeof(carl9170_fw_desc) > CARL9170_FW_DESC_MAX_LENGTH);
}

#endif	/* __HDR_H */
