/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __TYPES_H
#define __TYPES_H

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <sys/param.h>

#if BYTE_ORDER == LITTLE_ENDIAN
typedef uint16_t	__le16;
typedef uint32_t	__le32;
typedef uint64_t	__le64;

#define cpu_to_le16(x) ((__le16)(uint16_t)(x))
#define le16_to_cpu(x) ((uint16_t)(__le16)(x))
#define cpu_to_le32(x) ((__le32)(uint32_t)(x))
#define le32_to_cpu(x) ((uint32_t)(__le32)(x))
#define cpu_to_le64(x) ((__le64)(uint64_t)(x))
#define le64_to_cpu(x) ((uint64_t)(__le64)(x))

#else
#error	"big endian is not supported by target"
#endif

#endif	/* __TYPES_H */
