/*
 * Copyright (c) 2000-2005 ZyDAS Technology Corporation
 * Copyright (c) 2007-2009 Atheros Communications, Inc.
 * Copyright	2009	Johannes Berg <johannes@sipsolutions.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __USB_TYPE_H
#define __USB_TYPE_H

#include "types.h"

/*********************** for Faraday USB controller *******************/

#define mWORD_IDX(bsize)        ((bsize) >> 1)
#define mWORD_SIZE(bsize)       (((bsize) + 1) >> 1)

#define mTABLE_IDX              mWORD_IDX
#define mTABLE_LEN              mLOW_BYTE

#define mLOW_MASK(u16)          ((uint8_t) ((uint16_t) &MASK(8)))
#define mHIGH_MASK(u16)         ((uint8_t) ((uint16_t) &~MASK(8)))
#define mLOW2HIGH(u16)          (((uint8_t) (uint16_t)) << 8)

/* (1234) -> 0034 */
#define mLOW_BYTE(u16)          mLOW_MASK(u16)

/* (1234) -> 0012 */
#define mHIGH_BYTE(u16)         ((uint8_t) (((uint16_t) (u16)) >> 8))

#define mGET_REG1(var0, reg0)       { var0 = reg0; }

#define mREAD_WORD(var0, reg0, reg1)    \
    { var0 = reg0; var0 += mLOW2HIGH(reg1); }

#endif	/* __USB_TYPE_H */
